Summary:	Remote desktop server
Summary(pl.UTF-8):	Serwer remote desktop
Name:		xrdp
Version:	0.9.21
Release:	1
License:	Apache v2.0
Group:		X11/Applications/Networking
#Source0Download: https://github.com/neutrinolabs/xrdp/releases
Source0:	https://github.com/neutrinolabs/xrdp/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	f72647504d6388dd31be55715c10ffba
Source1:	%{name}.init
Source2:	%{name}.pamd
Source3:	%{name}.README.PLD
Source4:	%{name}.README.PLD.pl
Source5:	startwm.sh
Patch0:		config.patch
Patch1:		quiet.patch
Patch2:		x32.patch
URL:		http://xrdp.org/
BuildRequires:	autoconf >= 2.65
BuildRequires:	automake >= 1:1.7.2
BuildRequires:	fdk-aac-devel >= 0.1.0
BuildRequires:	imlib2-devel >= 1.4.5
BuildRequires:	lame-libs-devel
BuildRequires:	libfuse-devel >= 2.6
BuildRequires:	libjpeg-turbo-devel
BuildRequires:	libtool
BuildRequires:	nasm
BuildRequires:	openssl-devel >= 0.9.8
BuildRequires:	opus-devel
BuildRequires:	pam-devel
BuildRequires:	pixman-devel >= 0.1.0
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	systemd-units
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXfixes-devel
BuildRequires:	xorg-lib-libXrandr-devel
Requires(post,preun):	/sbin/chkconfig
Requires(post,preun,postun):	systemd-units >= 38
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	%{name}-libs = %{version}-%{release}
Requires:	/usr/bin/Xvnc
Requires:	fdk-aac >= 0.1.0
Requires:	imlib2 >= 1.4.5
Requires:	libfuse >= 2.6
Requires:	openssl >= 0.9.8
Requires:	pixman >= 0.1.0
Requires:	rc-scripts
Requires:	systemd-units >= 38
Requires:	xinitrc-ng
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
xrdp is an open source Remote Desktop Protocol (rdp) server for
UNIX-like systems. It is capable of accepting connections from
rdesktop and Microsoft's own terminal server / remote desktop clients.

Unlike Windows NT/2000/2003 server, xrdp will not display a Windows
desktop but an X window desktop to the user.

Xrdp uses Xvnc or X11rdp backends to manage the X session.

%description -l pl.UTF-8
xrdp jest serwerem protokołu Remote Desktop (rdp) dla systemów
UNIXowych. Do xrdp można się łączyć zarówno programem rdesktop, jak i
klientami protokołu rdp Microsoftu.

xrdp używa jako backendu Xvnc lub X11rdp.

%package libs
Summary:	xrdp shared libraries
Summary(pl.UTF-8):	Biblioteki współdzielone xrdp
Group:		Libraries

%description libs
xrdp shared libraries.

%description libs -l pl.UTF-8
Biblioteki współdzielone xrdp.

%package devel
Summary:	Header files for xrdp libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek xrdp
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for xrdp libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek xrdp.

%package static
Summary:	Static xrdp libraries
Summary(pl.UTF-8):	Statyczne biblioteki xrdp
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static xrdp libraries.

%description static -l pl.UTF-8
Statyczne biblioteki xrdp.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

install %{SOURCE3} README.PLD
install %{SOURCE4} README.PLD.pl

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd libpainter
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../librfxcodec
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
cd ..
%configure \
	--enable-fdkaac \
	--enable-fuse \
	--enable-ipv6 \
	--enable-mp3lame \
	--enable-opus \
	--enable-pam-config=redhat \
	--enable-painter \
	--enable-pixman \
	--disable-silent-rules \
	--enable-tjpeg \
	--enable-vsock \
	--with-imlib2

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/%{name},/etc/{pam.d,rc.d/init.d,security}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/xrdp
install %{SOURCE2} $RPM_BUILD_ROOT/etc/pam.d/sesman
%{__rm} $RPM_BUILD_ROOT/etc/pam.d/xrdp-sesman
%{__ln_s} sesman $RPM_BUILD_ROOT/etc/pam.d/xrdp-sesman
:> $RPM_BUILD_ROOT/etc/security/blacklist.sesman

%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/startwm.sh
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/startwm.sh

%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{name}/lib*.{a,la}
# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.la

%pre
%groupadd -g 183 xrdp

%post
/sbin/chkconfig --add xrdp
%service xrdp restart "xrdp server"
%systemd_post xrdp.service xrdp-sesman.service

%preun
if [ "$1" = "0" ]; then
	%service xrdp stop
	/sbin/chkconfig --del xrdp
fi
%systemd_preun xrdp.service xrdp-sesman.service

%postun
if [ "$1" = "0" ]; then
	%groupremove xrdp
fi
%systemd_reload

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING NEWS.md README.md README.PLD
%lang(pl) %doc README.PLD.pl
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/sesman
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/security/blacklist.sesman
%attr(640,root,root) /etc/pam.d/xrdp-sesman
%attr(754,root,root) /etc/rc.d/init.d/xrdp
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/pulse
%config(noreplace) %{_sysconfdir}/%{name}/cert.pem
%config(noreplace) %{_sysconfdir}/%{name}/key.pem
%config(noreplace) %{_sysconfdir}/%{name}/rsakeys.ini
%config(noreplace) %{_sysconfdir}/%{name}/sesman.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp.ini
%config(noreplace) %{_sysconfdir}/%{name}/xrdp_keyboard.ini
%{_sysconfdir}/%{name}/km-*.ini
%config(noreplace) %{_sysconfdir}/%{name}/pulse/default.pa
%attr(755,root,root) %{_sysconfdir}/xrdp/reconnectwm.sh
%attr(755,root,root) %{_sysconfdir}/xrdp/startwm.sh
%attr(755,root,root) %{_bindir}/xrdp-dis
%attr(755,root,root) %{_bindir}/xrdp-genkeymap
%attr(755,root,root) %{_bindir}/xrdp-keygen
%attr(755,root,root) %{_bindir}/xrdp-sesadmin
%attr(755,root,root) %{_bindir}/xrdp-sesrun
%attr(755,root,root) %{_sbindir}/xrdp
%attr(755,root,root) %{_sbindir}/xrdp-chansrv
%attr(755,root,root) %{_sbindir}/xrdp-sesman
%dir %{_libdir}/xrdp
%attr(755,root,root) %{_libdir}/xrdp/libcommon.so*
%attr(755,root,root) %{_libdir}/xrdp/libmc.so*
%attr(755,root,root) %{_libdir}/xrdp/libscp.so*
%attr(755,root,root) %{_libdir}/xrdp/libvnc.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdp.so*
%attr(755,root,root) %{_libdir}/xrdp/libxrdpapi.so*
%attr(755,root,root) %{_libdir}/xrdp/libxup.so*
%{systemdunitdir}/xrdp.service
%{systemdunitdir}/xrdp-sesman.service
%dir %{_datadir}/xrdp
%{_datadir}/xrdp/ad24b.bmp
%{_datadir}/xrdp/ad256.bmp
%{_datadir}/xrdp/cursor0.cur
%{_datadir}/xrdp/cursor1.cur
%{_datadir}/xrdp/sans-10.fv1
%{_datadir}/xrdp/xrdp24b.bmp
%{_datadir}/xrdp/xrdp256.bmp
%{_datadir}/xrdp/xrdp_logo.bmp
%{_mandir}/man1/xrdp-dis.1*
%{_mandir}/man5/sesman.ini.5*
%{_mandir}/man5/xrdp.ini.5*
%{_mandir}/man8/xrdp-chansrv.8*
%{_mandir}/man8/xrdp-genkeymap.8*
%{_mandir}/man8/xrdp-keygen.8*
%{_mandir}/man8/xrdp-sesadmin.8*
%{_mandir}/man8/xrdp-sesman.8*
%{_mandir}/man8/xrdp-sesrun.8*
%{_mandir}/man8/xrdp.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpainter.so.0
%attr(755,root,root) %{_libdir}/librfxencode.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/librfxencode.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.so
%attr(755,root,root) %{_libdir}/librfxencode.so
%{_includedir}/ms-*.h
%{_includedir}/painter.h
%{_includedir}/rfxcodec_common.h
%{_includedir}/rfxcodec_decode.h
%{_includedir}/rfxcodec_encode.h
%{_includedir}/xrdp_client_info.h
%{_includedir}/xrdp_constants.h
%{_includedir}/xrdp_rail.h
%{_includedir}/xrdp_sockets.h
%{_pkgconfigdir}/libpainter.pc
%{_pkgconfigdir}/rfxcodec.pc
%{_pkgconfigdir}/xrdp.pc

%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpainter.a
%attr(755,root,root) %{_libdir}/librfxencode.a
%changelog
* Sat Dec 10 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xrdp.git;a=log;h=master

* Sat Dec 10 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 10ab564
- 0.9.21

* Sat Sep 17 2022 Jakub Bogusz <qboosh@pld-linux.org> 0a3433c
- versioned imlib dependency, don't hide individual autotools calls behind autoreconf

* Thu Sep 15 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 48c2a7c
- up to 0.9.20

* Tue Mar 22 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 0c68619
- removing unused patches and adding linker patch

* Tue Mar 22 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> df4b97b
- up to 0.9.19

* Mon Feb 28 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 39298ec
- up to 0.9.18.1, problem with unresolved symbols

* Sun Oct 03 2021 Jan Rękorajski <baggins@pld-linux.org> caf09c0
- rediff config patch
- disable Werror due to deprecated OpenSSL APIs used here
- rel 3

* Sat Nov 07 2020 Jakub Bogusz <qboosh@pld-linux.org> 6daa95b
- ghost soname symlinks, unified subpackage names
- license is Apache v2.0
- release 2

* Sat Nov 07 2020 Jan Palus <atler@pld-linux.org> 55cacc9
- fix build on archs with 32bit pointers

* Fri Nov 06 2020 Jan Palus <atler@pld-linux.org> f1da7c1
- updated deps; enabled more features

* Fri Nov 06 2020 Jan Palus <atler@pld-linux.org> 782957f
- up to 0.9.14 (fixes CVE-2022-4044)

* Sat Apr 20 2019 Adam Gołębiowski <adamg@pld-linux.org> 6732daf
- updated to 0.9.10

* Mon Oct 22 2018 Jan Rękorajski <baggins@pld-linux.org> 1c80cff
- fix building on x32
- rel 2

* Mon Oct 22 2018 Jan Rękorajski <baggins@pld-linux.org> 19c5895
- up to 0.9.8
- freerdp is only needed for optional neutrinordp module, disable it

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> c8ec07d
- release 2 (by relup.sh)

* Thu Sep 06 2018 Marcin Krol <hawk@tld-linux.org> 185a953
- merged version 0.9.7 from TLD Linux:
  * patch bundled *.ini files instead of keeping local copy
  * create special group xrdp for allowed users
  * deny root login by default
  * added script for starting selected WM
  * higher loglevel
  * dropped kerberos auth, there is no pam fallback which prevents
    user login

* Sat Dec 07 2013 Jan Rękorajski <baggins@pld-linux.org> f36b3e9
- up to 0.6.1
- fix format string errors
- fix build with heimdal krb5
- other small fixes
- updated configs and init script

* Sat Apr 02 2011 Jarosław Skibiński <skibi@pld-linux.org> 17c05fb
- Update to versin 0.4.2

* Fri Apr 30 2010 pawelz <pawelz@pld-linux.org> 70884b4
- rel 3

* Tue Dec 30 2008 pawelz <pawelz@pld-linux.org> af532d7
- added note about signals.patch

